export function pathLineAtOffset(coords, offset) {
  var totalDistance = 0;
  var cachePoints = [];

  for (var i = 0; i < coords.length - 1; i++) {
    var p1 = coords[i];
    var p2 = coords[i + 1];
    var distance = calDistance(p1, p2);
    var lastTotalDistance = totalDistance;
    totalDistance += distance;
    cachePoints.push({
      p1: p1,
      p2: p2,
      totalDistance: totalDistance,
      distance: distance,
      lastTotalDistance: lastTotalDistance
    });
  }

  var offsetDistance = totalDistance * offset;

  var _lng, _lat;

  for (var _i = 0; _i < cachePoints.length; _i++) {
    var currentDistance = cachePoints[_i].totalDistance;

    if (currentDistance > offsetDistance) {
      var _p = cachePoints[_i].p1;
      var _p2 = cachePoints[_i].p2;
      var radius = (offsetDistance - cachePoints[_i].lastTotalDistance) / cachePoints[_i].distance;
      var offsetPoint = mixPoint(_p2, _p, radius);
      _lng = offsetPoint[0];
      _lat = offsetPoint[1];
      break;
    }
  }

  return {
    _lng: _lng,
    _lat: _lat,
    _height: 0
  };
}

function mixPoint(p1, p2, r) {
  return [p1[0] * r + p2[0] * (1 - r), p1[1] * r + p2[1] * (1 - r)];
}

function calDistance(p1, p2) {
  return Math.sqrt(Math.pow(p1[0] - p2[0], 2) + Math.pow(p1[1] - p2[1], 2));
}