import { TileBounds, TileLoadDataOptions, TileOptions } from './types';
import { EventEmitter } from 'eventemitter3';
/**
 * 单个瓦片
 * 负责瓦片数据加载、缓存数据、缓存图层
 */
export declare class Tile extends EventEmitter {
    x: number;
    y: number;
    z: number;
    tileSize: number;
    isVisible: boolean;
    isCurrent: boolean;
    isVisibleChange: boolean;
    parentLayerIDList: string[];
    layerIDList: string[];
    loadedLayers: number;
    parent: Tile | null;
    children: Tile[];
    loadedChilds: number;
    data: any;
    properties: Record<string, any>;
    xhrCancel?: () => void;
    private loadStatus;
    private abortController;
    private loadDataId;
    constructor(options: TileOptions);
    get isLoading(): boolean;
    get isLoaded(): boolean;
    get isFailure(): boolean;
    get isCancelled(): boolean;
    get isDone(): boolean;
    get bounds(): TileBounds;
    get bboxPolygon(): import("@turf/helpers").Feature<import("@turf/helpers").Polygon, {
        key: string;
        bbox: TileBounds;
        center: readonly [number, number];
        meta: string;
    }>;
    get key(): string;
    layerLoad(): void;
    loadData({ getData, onLoad, onError }: TileLoadDataOptions): Promise<void>;
    reloadData(params: TileLoadDataOptions): void;
    abortLoad(): void;
}
